import serial
import time
#import socket
#import datetime

from generic_module import Module

class HistModule(Module):
  def __init__(self, name, udp_ip, udp_port, serial_port, baud, interval, root_path):
    Module.__init__(self, name, root_path)
    self.udp_ip = udp_ip
    self.udp_port = udp_port
    self.serial_port = serial_port
    self.baud = baud
    self.interval = interval
    
    #self.vpn_host = vpn_host
    #self.vpn_port = vpn_port
    
  #def generate_path(self):
    #pth = self.sites_path
    #pth = pth + "/" + self.sname
    #if not os.path.exists(pth):
      #os.mkdir(pth)
    #pth = pth + "/ext"
    #if not os.path.exists(pth):
      #os.mkdir(pth)
    #pth = pth + "/temperature"
    #if not os.path.exists(pth):
      #os.mkdir(pth)
    """
    pth = pth + "/" + self.typ
    if not os.path.exists(pth):
      os.mkdir(pth)
    pth = pth + "/" + self.name 
    if not os.path.exists(pth):
      os.mkdir(pth)
    
    #print pth
    return pth
    """
  
  def histcmd(self, ser, cmnd, resp = '', to = 0.5):
    if ser.timeout != to:
      ser.timeout = to
    ser.flushInput()
    ser.write(cmnd + '\n')
    r = []
    while True:
      l = ser.readline().rstrip();
      if l == '': # EOF
        return r
      r.append(l)
      if len(resp) > 0 and l.find(resp) != -1: # resp found
        return r
      if len(r) > 10: # safeguard
        return r
  
  def dict2confstr(self, section, d):
    r = '[' + section + ']' + '\n'
    for k,v in d.iteritems():
      r += k + '=' + v + '\n'
    return r
  
  def run(self):
    self.alive = True
    self.end = False
    even_odd_flag = 1
    try:
      ser = serial.Serial(self.serial_port, self.baud)
      try:
        while True:
          #a temporary hack!
          if even_odd_flag == 0:
            even_odd_flag = 1
          else:
            even_odd_flag = 0
          if self.end:
            ser.close()
            self.alive = False
            return
          #sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
          #result = sock.connect_ex((self.vpn_host, self.vpn_port))
          #try:
            #sock.close()
          #except Exception:
            #pass
          #if result == 0: 
            #self.ctucmd(ser, 'vPNON')
          d = {}
          #d['dev'] = 'CTU-03';
          d['ts'] = time.strftime('%Y-%m-%d-%H-%M-%S')
          #r = self.ctucmd(ser, 'FWVER ')
          #if len(r) == 1:
            #j = r[0].find('firmware ver') 
            #if j != -1:
              #d['fw'] = r[0][j+12:].rstrip()
          r = self.histcmd(ser, 'STAT')
          for p in r:
            parts = p.split("=")
            try:
              d[parts[0]] = parts[1]
            except Exception:
              pass
          #print d
          #r_parts = r.split(", ")
          #del(r_parts[0])
          #for i in range(len(r_parts)):
            #r_parts[i].replace("'", "")
            #r_parts[i].replace("]", "")
          #print r_parts
          #for i in range(len(r)):
            #s = r[i].split('=')
            #if len(s) == 2:
              #j = -1
              #u = '__?'
              #if s[0].startswith('U'):
                #j = s[1].find('V')
                #u = '__V'
              #if s[0].startswith('T'):
                #j = s[1].find('C')
                #u = '__C'
              #if j != -1:
                #d[s[0]+u] = s[1][:j]
          #try:
            #if even_odd_flag == 0:
              #line = d['ts'] + "\t" + d['Ub__V'] + "\t" + d['Ti__C']
              #for i in range(1, 6):
                #line = line + "\t" + d['T' + str(i) + "__C"]
              #line = line + "\n"
              #fd = open("D:/siwim_mkiii/siwim_e/log/ctu_" +  datetime.datetime.today().strftime('%Y-%m-%d') + ".txt", "a")
              #fd.write(line)
              #fd.close()
          #except Exception, ex:
            #print str(ex)
          try:
            for key, mod in self.downstream_modules_dict.iteritems():
              mod.set_hist_data(d['sw_ver'], d['Ub__V'])
          except Exception, ex:
            pass
          #if 'Ti__C' in d:
            #msg = self.dict2confstr('mydevice', {"ts":d["ts"],"Ub__V":d["Ub__V"],"Ti__C":d["Ti__C"]}) #json.dumps(d)
            #self.log(msg) #DEBUG
            #sock = socket.socket(socket.AF_INET, socket.SOCK_DGRAM)
            #try:
              #sock.sendto(msg, (self.udp_ip, self.udp_port))
            #finally:
              #sock.close()
          self.zzzzz(self.interval)
      finally:
        ser.close()
    except Exception, ex:
      self.log(str(ex))
      self.alive = False

